---
title: ServiceWorkerRegistration
slug: Web/API/ServiceWorkerRegistration
tags:
  - API
  - Interface
  - Offline
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorkerRegistration
  - Workers
---
<div>
<div>{{APIRef("Service Workers API")}}</div>
</div>

<p><span class="seoSummary">The <strong><code>ServiceWorkerRegistration</code></strong> interface of the <a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API</a> represents the service worker registration. You register a service worker to control one or more pages that share the same origin.</span></p>

<p>The lifetime of a service worker registration is beyond that of the <code>ServiceWorkerRegistration</code> objects that represent them within the lifetime of their corresponding service worker clients. The browser maintains a persistent list of active <code>ServiceWorkerRegistration</code> objects.</p>

<div class="note">
<p><strong>Note</strong>: This feature is available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a>.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em>Also implements properties from its parent interface, </em>{{domxref("EventTarget")}}.</p>

<dl>
 <dt>{{domxref("ServiceWorkerRegistration.scope")}} {{readonlyinline}}</dt>
 <dd>Returns a unique identifier for a service worker registration. This must be on the same origin as the document that registers the {{domxref("ServiceWorker")}}.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.installing")}} {{readonlyinline}}</dt>
 <dd>Returns a service worker whose state is <code>installing</code>. This is initially set to <code>null</code>.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.waiting")}} {{readonlyinline}}</dt>
 <dd>Returns a service worker whose state is <code>installed</code>. This is initially set to <code>null</code>.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.active")}} {{readonlyinline}}</dt>
 <dd>Returns a service worker whose state is <code>activating</code> or <code>activated</code>. This is initially set to <code>null</code>. An active worker will control a {{domxref("ServiceWorkerClient")}} if the client's URL falls within the scope of the registration (the <code>scope</code> option set when {{domxref("ServiceWorkerContainer.register")}} is first called.)</dd>
 <dt>{{domxref("ServiceWorkerRegistration.navigationPreload")}} {{readonlyinline}}</dt>
 <dd>Returns the instance of {{domxref("NavigationPreloadManager")}} associated with the current service worker registration.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.pushManager")}} {{readonlyinline}}</dt>
 <dd>Returns a reference to the {{domxref("PushManager")}} interface for managing push subscriptions including subscribing, getting an active subscription, and accessing push permission status.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.sync")}} {{non-standard_inline}} {{readonlyinline}} </dt>
 <dd>Returns a reference to the {{domxref("SyncManager")}} interface, which manages background synchronization processes.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.index")}} {{readonlyinline}} </dt>
 <dd>Returns a reference to the {{domxref("ContentIndex")}} interface, for managing indexed content for offline viewing.</dd>
</dl>

<h3 id="Unimplemented_properties">Unimplemented properties</h3>

<dl>
 <dt>{{domxref("serviceWorkerRegistration.periodicSync")}} {{non-standard_inline}} {{readonlyinline}}</dt>
 <dd>Returns a reference to the {{domxref("PeriodicSyncManager")}} interface, which manages periodic background synchronization processes. This was mentioned as an idea in the SW explainer at some point, but as yet has not been implemented anywhere.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("ServiceWorkerRegistration.onupdatefound")}} {{readonlyinline}}</dt>
 <dd>An <a href="/en-US/docs/Web/API/EventListener" title="This method is called whenever an event occurs of the type for which the EventListener interface was registered."><code>EventListener</code></a> property called whenever an event of type <code>updatefound</code> is fired; it is fired any time the {{domxref("ServiceWorkerRegistration.installing")}} property acquires a new service worker.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Also implements methods from its parent interface, </em>{{domxref("EventTarget")}}.</p>

<dl>
 <dt>{{domxref("ServiceWorkerRegistration.getNotifications()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves to an array of {{domxref("Notification")}} objects.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.showNotification()")}}</dt>
 <dd>Displays the notification with the requested title.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.update()")}}</dt>
 <dd>Checks the server for an updated version of the service worker without consulting caches.</dd>
 <dt>{{domxref("ServiceWorkerRegistration.unregister()")}}</dt>
 <dd>Unregisters the service worker registration and returns a {{jsxref("Promise")}}. The service worker will finish any ongoing operations before it is unregistered.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example, the code first checks whether the browser supports service workers and if so registers one. Next, it adds an <code>updatefound</code> listener in which it uses the service worker registration to listen for further changes to the service worker's state. If the service worker hasn't changed since the last time it was registered, then the <code>updatefound</code> event will not be fired.</p>

<pre class="brush: js notranslate">if ('serviceWorker' in navigator) {
  navigator.serviceWorker.register('/sw.js')
  .then(function(registration) {
    registration.addEventListener('updatefound', function() {
      // If updatefound is fired, it means that there's
      // a new service worker being installed.
      var installingWorker = registration.installing;
      console.log('A new service worker is being installed:',
        installingWorker);

      // You can listen for changes to the installing service worker's
      // state via installingWorker.onstatechange
    });
  })
  .catch(function(error) {
    console.log('Service worker registration failed:', error);
  });
} else {
  console.log('Service workers are not supported.');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#serviceworkerregistration', 'ServiceWorkerRegistration')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('Push API', '#dom-serviceworkerregistration-pushmanager', 'PushManager')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Adds the {{domxref("PushManager","pushManager")}} property.</td>
  </tr>
  <tr>
   <td>{{SpecName('Web Notifications')}}</td>
   <td>{{Spec2('Web Notifications')}}</td>
   <td>Adds the {{domxref("ServiceWorkerRegistration.showNotification()","showNotification()")}} method and the {{domxref("ServiceWorkerRegistration.getNotifications()","getNotifications()")}} method.</td>
  </tr>
  <tr>
   <td>{{SpecName('Background Sync')}}</td>
   <td>{{Spec2('Background Sync')}}</td>
   <td>Adds the {{domxref("ServiceWorkerRegistration.sync","sync")}} property.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ServiceWorkerRegistration")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise")}}</li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using web workers</a></li>
</ul>
